<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../../common/content-types';
import { getClient } from '../../../plugins/contentful.js';
import { getPageMetadata } from '~/common/meta';
import { FooterEditLinkMixin, ImageUrlMixin } from '~/mixins';

import { Modal as SlpModal } from '~/components/common/index.vue';

export default Vue.extend({
  name: 'BoardOfDirectors',
  components: {
    SlpModal,
  },
  mixins: [FooterEditLinkMixin, ImageUrlMixin],
  async asyncData() {
    try {
      const content = await await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'company/team/board-of-directors',
        include: 10,
      });

      const spaceId = content.items[0].sys.space.sys.id;
      const entryId = content.items[0].sys.id;
      const doc = content.items[0].fields.pageContent[0].fields;
      const cta = content.items[0].fields.pageContent[1].fields;

      const metadata = {
        title: content.items[0].fields.seoMetadata[0].fields.title,
        description: content.items[0].fields.seoMetadata[0].fields.description,
      };

      return { doc, cta, metadata, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  nuxtI18n: false,
  data() {
    return {
      isModalOpen: false,
      modalInfo: {},
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
  methods: {
    openModal(info: object) {
      this.isModalOpen = true;
      this.modalInfo = info;
    },
    closeModal() {
      this.isModalOpen = false;
    },
  },
});
</script>

<template>
  <section class="background-purple">
    <SlpContainer class="board">
      <div class="board__gradient-header slp-mt-48" />
      <SlpRow class="slp-mb-md-96 slp-mb-48">
        <SlpTypography tag="h2" variant="heading2-bold">
          {{ doc.header }}
        </SlpTypography>
      </SlpRow>
      <SlpRow>
        <SlpColumn
          v-for="headshot in doc.card"
          :key="headshot.fields.title"
          class="slp-mb-64 board__wrapper"
          :cols="6"
          size="lg"
        >
          <div class="board__headshot" @click="openModal(headshot)">
            <img
              class="board__headshot__image"
              :src="
                parseImageUrl(headshot.fields.image.fields.file.url, 440, 480)
              "
              :alt="headshot.fields.image.fields.title"
            />
            <div class="board__headshot-body">
              <SlpTypography class="slp-mb-32" tag="h4" variant="heading4-bold">
                {{ headshot.fields.title }}
              </SlpTypography>
              <SlpTypography
                v-if="headshot.fields.subtitle"
                tag="p"
                variant="body1"
              >
                {{ headshot.fields.subtitle }}
              </SlpTypography>
              <SlpButton
                class="slp-mt-24"
                variant="tertiary"
                data-ga-location="body"
                :data-ga-name="headshot.fields.title"
                @click="openModal(headshot)"
              >
                Learn more
                <SlpIcon name="chevron-lg-right" variant="product" />
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
      <SlpRow class="board__more-links">
        <SlpButton
          :data-ga-location="doc.cta.fields.dataGaLocation"
          :data-ga-name="doc.cta.fields.dataGaName"
          :href="doc.cta.fields.externalUrl"
          class="slp-my-48"
          variant="tertiary"
        >
          {{ doc.cta.fields.text }}
          <SlpIcon name="chevron-lg-right" variant="product" />
        </SlpButton>
      </SlpRow>
      <SlpRow class="board__more-links">
        <SlpButton
          :data-ga-location="cta.dataGaLocation"
          :data-ga-name="cta.dataGaName"
          :href="cta.externalUrl"
          class="slp-my-48"
          variant="tertiary"
        >
          {{ cta.text }}
          <SlpIcon name="chevron-lg-right" variant="product" />
        </SlpButton>
      </SlpRow>
      <SlpModal v-if="isModalOpen" class="board__modal" @close="closeModal">
        <div class="board__modal-content">
          <SlpTypography tag="h3" variant="heading3-bold">
            {{ modalInfo.fields.title }}
          </SlpTypography>
          <div
            class="board__modal-story"
            v-html="$md.render(modalInfo.fields.description)"
          ></div>
        </div>
      </SlpModal>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.background-purple {
  background-color: $color-surface-800;
}

.board {
  &__wrapper {
    flex: 1;
  }

  &__gradient-header {
    background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
    height: 4px;
    width: 95px;
    border-radius: 10px;
    margin-bottom: $spacing-16;
  }

  &__headshot {
    height: 100%;
    background: $color-primary-300;
    border-radius: 20px;
    display: flex;
    flex-direction: column;
    position: relative;

    @media (min-width: $breakpoint-md) {
      &:nth-child(even) {
        margin-left: $spacing-48;
      }

      &:nth-child(odd) {
        margin-right: $spacing-48;
      }
    }

    &__image {
      object-fit: cover;
      object-position: top;
      max-height: 240px;
      height: 240px;

      @media (min-width: $breakpoint-md) {
        position: absolute;
        top: -32px;
        left: -20px;
        max-width: 220px;
        width: 220px;
        border-bottom-right-radius: 100px;
      }
    }

    &:hover {
      cursor: pointer;
    }
  }

  &__headshot-body {
    padding: $spacing-32;
    min-height: 250px;

    @media (min-width: $breakpoint-md) {
      padding-left: 250px;
    }
  }

  &__more-links {
    justify-content: center;
  }

  &__modal-story &:deep p {
    padding-top: 20px;
  }

  &__modal-content {
    max-width: 800px;
    padding: 32px;

    &:deep p {
      padding-top: 20px;
    }

    &:deep h5 {
      font-size: 20px;
      padding-top: 20px;
      font-weight: 600;
      line-height: 24px;
    }

    @media (max-width: $breakpoint-md) {
      max-height: 90vh;
      overflow-y: auto;
    }
  }
}
</style>
